<template>
    <div>

        <el-card class="!border-none" v-loading="pager.loading" shadow="never">
            <el-button v-perms="['project.project/add']" type="primary" @click="handleAdd">
                <template #icon>
                    <icon name="el-icon-Plus" />
                </template>
                新增
            </el-button>
            <el-button v-perms="['project.project/delete']" :disabled="!selectData.length"
                @click="handleDelete(selectData)">
                删除
            </el-button>

            <div class="mt-4">
                <el-table border :data="pager.lists" @selection-change="handleSelectionChange">
                    <el-table-column type="selection" width="55" />
                    <el-table-column label="序号" type="index" width="55" />
                    <el-table-column label="项目名称" prop="project_name" show-overflow-tooltip />
                    <el-table-column label="项目编码" prop="project_code" show-overflow-tooltip />
                    <el-table-column label="日志详情" prop="content" show-overflow-tooltip />
                    <el-table-column label="添加人" prop="add_user_name" show-overflow-tooltip />
                    <el-table-column label="创建日期" prop="create_time" show-overflow-tooltip />
                    <el-table-column label="操作" width="160" fixed="right" align="center">

                        <template #default="{ row }">
                            <el-button v-perms="['project.project/edit']" type="primary" link @click="handleEdit(row)">
                                编辑
                            </el-button>
                            <el-button v-perms="['project.project/delete']" type="danger" link
                                @click="handleDelete(row.id)">
                                删除
                            </el-button>
                            <el-button v-perms="['project.project/detail']" link @click="handleDetail(row.id)">
                                详情
                            </el-button>

                        </template>
                    </el-table-column>
                </el-table>
            </div>
            <div class="flex justify-end mt-4">
                <pagination v-model="pager" @change="getLists" />
            </div>
        </el-card>
        <edit-popup v-if="showEdit" ref="editRef" :dict-data="dictData" @success="getLists" @close="showEdit = false" />
        <detailPage v-if="showDetail" ref="detailRef" @close="showDetail = false" :detailConfig="detailConfig" :column="1"
            width="550px" />
    </div>
</template>

<script lang="ts" setup name="projectLists">
import { usePaging } from '@/hooks/usePaging'
import { useDictData } from '@/hooks/useDictOptions'
import { apiProjectlogsLists, apiProjectlogsDelete, apiProjectlogsDetail } from '@/api/project_logs'
import { timeFormat } from '@/utils/util'
import { getAllProjectTypes } from '@/api/projecttype'
const protype = reactive([])
import feedback from '@/utils/feedback'
import EditPopup from './edit.vue'
const detailRef = shallowRef<InstanceType<typeof DetailPopup>>()
const editRef = shallowRef<InstanceType<typeof EditPopup>>()
import detailConfig from './detail'

// 是否显示编辑框
const showEdit = ref(false)
const showDetail = ref(false)

// 查询条件
const queryParams = reactive({
    // name: ''


})

// 选中数据
const selectData = ref<any[]>([])

// 表格选择后回调事件
const handleSelectionChange = (val: any[]) => {
    selectData.value = val.map(({ id }) => id)
}

// 获取字典数据
const { dictData } = useDictData('follow_type')
// 分页相关
const { pager, getLists, resetParams, resetPage } = usePaging({
    fetchFun: apiProjectlogsLists,
    params: queryParams
})

// 添加
const handleAdd = async () => {
    showEdit.value = true
    await nextTick()
    editRef.value?.open('add')
}


// 编辑
const handleEdit = async (data: any) => {
    let res = await apiProjectlogsDetail({ id: data.id })
    showEdit.value = true
    await nextTick()
    editRef.value?.open('edit')
    editRef.value?.setFormData(res)
}

// 删除
const handleDelete = async (id: number | any[]) => {
    await feedback.confirm('确定要删除？')
    await apiProjectlogsDelete({ id })
    getLists()
}
// 详情
const handleDetail = async (id: any) => {
    let res = await apiProjectlogsDetail({ id })
    showDetail.value = true
    await nextTick()
    detailRef.value?.open()
    detailRef.value?.setFormData(res)
}

getLists()
</script>
